# NatPunchthroughServer Class Reference
[NatPunchthrough]

`#include <NatPunchthroughServer.h>`

Inheritance diagram for NatPunchthroughServer:

List of all members.

## Public Member Functions

| NatPunchthroughServer ()
| Constructor.
virtual | ~NatPunchthroughServer ()
| Destructor.
void | SetDebugInterface (NatPunchthroughServerDebugInterface *i)
virtual void | Update (void)
| Update is called every time a packet is checked for .
virtual PluginReceiveResult | OnReceive (Packet *packet)
virtual void | OnClosedConnection (SystemAddress systemAddress, RakNetGUID rakNetGUID, PI2_LostConnectionReason lostConnectionReason)
virtual void | OnNewConnection (SystemAddress systemAddress, RakNetGUID rakNetGUID, bool isIncoming)

## Detailed Description

Maintain connection to NatPunchthroughServer to process incoming connection attempts through NatPunchthroughClient Server maintains two sockets clients can connect to so as to estimate the next port choice Server tells other client about port estimate, current public port to the server, and a time to start connection attempts

## Member Function Documentation

void NatPunchthroughServer::OnClosedConnection | ( | SystemAddress | systemAddress,
|  | RakNetGUID | rakNetGUID,
|  | PI2_LostConnectionReason | lostConnectionReason |
| ) |  |  | `[virtual]`

Called when a connection is dropped because the user called RakPeer::CloseConnection() for a particular system

Parameters:

  `[in]` | systemAddress | The system whose connection was closed
  `[in]` | rakNetGuid | The guid of the specified system
  `[in]` | lostConnectionReason | How the connection was closed: manually, connection lost, or notification of disconnection

Reimplemented from PluginInterface2.

void NatPunchthroughServer::OnNewConnection | ( | SystemAddress | systemAddress,
|  | RakNetGUID | rakNetGUID,
|  | bool | isIncoming |
| ) |  |  | `[virtual]`

Called when we got a new connection

Parameters:

  `[in]` | systemAddress | Address of the new connection
  `[in]` | rakNetGuid | The guid of the specified system
  `[in]` | isIncoming | If true, this is ID_NEW_INCOMING_CONNECTION, or the equivalent

Reimplemented from PluginInterface2.

PluginReceiveResult NatPunchthroughServer::OnReceive | ( | Packet * | packet | ) | `[virtual]`

OnReceive is called for every packet.

Parameters:

  `[in]` | packet | the packet that is being returned to the user

Returns:
  True to allow the game and other plugins to get this message, false to absorb it

Reimplemented from PluginInterface2.

void NatPunchthroughServer::SetDebugInterface | ( | NatPunchthroughServerDebugInterface * | i | ) |

Sets a callback to be called with debug messages

Parameters:

  `[in]` | i | Pointer to an interface. The pointer is stored, so don't delete it while in progress. Pass 0 to clear.

The documentation for this class was generated from the following files:

- C:/RakNet/Source/NatPunchthroughServer.h
- C:/RakNet/Source/NatPunchthroughServer.cpp